import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class CollectorsExample {
	static List<Person> getPersons() {
		List<Person> res = new ArrayList<>();
		for (int i = 0; i < 10; i++) {
			res.add(new Person());
		}
		return res;
		
	}
	
	static void example1() {
		List<Person> persons = getPersons();
		StringBuffer result = persons.stream()
				.filter(person -> person.getAge() > 20)
				.map(Person::getLastName)
				.collect(
						StringBuffer::new, // constructor
						StringBuffer::append, // accumulator
						StringBuffer::append // combiner
		);
		System.out.println(result.toString());
	}
	
	static void example2() {
		List<Person> persons = getPersons();
		String result = persons.stream()
				.filter(person -> person.getAge() > 20)
				.map(Person::getLastName)
				.collect(
						Collectors.joining()
		);
		System.out.println(result);
	}	
	
	static void example3() {
		List<Person> persons = getPersons();
		String result = persons.stream()
				.filter(person -> person.getAge() > 20)
				.map(Person::getLastName)
				.collect(
						Collectors.joining(", ")
		);
		System.out.println(result);
	}	
	
	static void example4() {
		List<Person> persons = getPersons();
		String result = persons.stream()
				.filter(person -> person.getAge() > 20)
				.map(Person::getLastName)
				.collect(
						Collectors.joining(", ", "{", "}")
		);
		System.out.println(result);
	}
	
	static void example5() {
		List<Person> persons = getPersons();
		ArrayList<String> result = persons.stream()
				.filter(person -> person.getAge() > 20)
				.map(Person::getLastName)
				.collect(
						ArrayList::new,    //constructor
						Collection::add,   //accumulator
						Collection::addAll //combiner
		);
		System.out.println(result);
	}	
	
	static void example6() {
		List<Person> persons = getPersons();
		Map<Integer, List<Person>> result = persons.stream()
				.collect(
						Collectors.groupingBy(Person::getAge)
				);
		System.out.println(result);
	}	
	
	static void example7() {
		List<Person> persons = getPersons();
		Map<Integer, Long> result =
			persons.stream()
				.collect(
					Collectors.groupingBy(
						Person::getAge,
						Collectors.counting() // "downstream collector"
					)
				);
		System.out.println(result);
	}		
	

	public static void main(String... args) {
		example5();
	}
}