import java.util.Arrays;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.function.Function;
import java.util.stream.Collectors;

public class Main {

	public static void main(String[] args) throws IOException {
		Files.lines(Paths.get("input.txt")).parallel()
			.map(s -> s.split("\\s+"))
			.flatMap(Arrays::stream)
			.filter(s -> !s.isEmpty())
			.collect(Collectors.groupingByConcurrent(Function.identity(), Collectors.counting()))
			.entrySet()
			.stream()
			.sorted((o2, o1) -> Long.compare(o1.getValue(), o2.getValue()))
			.limit(10).forEach(o -> System.out.println(o.getKey()));		
	}

}
